import { Metadata, Http } from '@zeedhi/core';
import { ITabsBeforeChangeEventParam, Form, Modal, ModalService, LoadingService } from '@zeedhi/common';
// import { TekGrid } from '@zeedhi/teknisa-components-vuetify';
import { DialogServiceCustom } from '@/services/DialogServiceCustom';
import { AlertServiceCustom } from '@/services/AlertServiceCustom';
import { InstanceService } from '@/services/InstanceService';
import Messages from '@/services/Messages';
import { IterableComponentRender } from '@zeedhi/teknisa-components-common';
import { FileUpload } from '@/services/FileUpload';

export class DemandManagementController {
	public defaultTimeoutTimer: any;

	public baseUrl = '';

	public callDescription = '';

	public callType = '';

	public callRelationship = '';

	public isLoadingDefault = false;

	public showDemandManagementForm = false;

    get isVisibleDemandManagementGrid() {
		return !this.showDemandManagementForm;
    }

	private modalAddCall!: Modal;

	private modalForwardCall!: Modal;

	private typeIsIEdit = false;

	private typeIsSEdit = false;

	private modalAddComments!: Modal;

	private modalUploadFile!: Modal;

	public onMountedGeneralCard() {
		this.baseUrl = process.env.VUE_APP_END_POINT;
		console.log(this.baseUrl);
	}

	public async onMountedDemandManagementGrid() {
		this.modalAddCall = await ModalService.createFromJson('demandManagement/modal/addCallDemandManagementModal', true);
		this.modalForwardCall = await ModalService.createFromJson('demandManagement/modal/forwardCallDemandManagementModal', true);
	}

	public onDestroyDemandManagementGrid() {
		this.modalAddCall?.destroy();
		this.modalForwardCall?.destroy();
	}

	public addButtonDemandManagementGrid() {
		this.modalAddCall.show();
	}

	// START CALL GRID ---
	public publicComment = false;

	public checkForwardCall() {
		// console.log(params);
		// return params.FORWARD_CALL_GRID === 'S';
		return true;
	}

	public async rowClickGridDemandManagement(params: any) {
		LoadingService.show('Carregando');
		this.publicComment = false;
		this.showDemandManagementForm = true;
		this.callDescription = params.row.REFERENCE;
		this.callType = params.row.TYPE;
		if (params.row.TYPE === 'I') {
			this.typeIsIEdit = true;
			this.typeIsSEdit = false;
		} else {
			this.typeIsIEdit = false;
			this.typeIsSEdit = true;
		}
		this.callRelationship = params.row.CALL_RELATIONSHIP;
		await this.fillCallForm();
		LoadingService.hide();
		// const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		// console.log(callFormInstance);
	}

	public async fillCallForm() {
		const sendObject = { params: {
				CALL_RELATIONSHIP: this.callRelationship,
				CALL_TYPE: this.callType,
			},
		};
		const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		// console.log('callFormInstance');
		// console.log(callFormInstance);
		const callData = await Http.get('call', sendObject);
		if (this.typeIsSEdit && callData.data.data.COMMENT_PUBLIC) {
			this.publicComment = true;
		}
		// console.log(callData);
		callFormInstance.value.clientIdEdit = callData.data.data.ID; // I S
		callFormInstance.value.teknisaIdEdit = callData.data.data.CALL_RELATIONSHIP; // I S
		callFormInstance.value.reportedByEdit = callData.data.data.REPORTER_NAME; // I S
		callFormInstance.value.referenceEdit = callData.data.data.REFERENCE; // I S
		callFormInstance.value.productEdit = callData.data.data.PRODUCT; // I S
		callFormInstance.value.productTypeEdit = callData.data.data.PRODUCT_TYPE_NAME; // S
		callFormInstance.value.screenNameEdit = callData.data.data.MENU_ITEM_ID; // I
		callFormInstance.value.versionEdit = callData.data.data.MENU_VERSION; // I S
		callFormInstance.value.devVersionEdit = callData.data.data.VERSION_DEV;
		callFormInstance.value.categoryEdit = callData.data.data.CLASSIFICATION;
		// callFormInstance.value.rotulesEdit = callData.data.
		callFormInstance.value.clientEdit = callData.data.data.NMRAZSOCCLIE;
		callFormInstance.value.descriptionEdit = callData.data.data.DESCRIPTION;

		// Requisição de categoria: findProductCallClassification
	}
	// END CALL GRID -----

	// START MODAL ADD CALL ----
	private typeIsIAdd = false;

	private typeIsSAdd = false;

	public clientNOTSelected = true;

	public productNOTSelected = true;

	public screenNameNOTSelected = true;

	public productTypeNOTSelected = true;

	public versionSNOTSelected = true;

	public releaseNOTSelected = true;

	public currentCustomer = '';

	public currentCustomerCorporateName = '';

	public currentSgSistema = '';

	public currentProductTypeName = '';

	public currentProductType = '';

	public currentVersionS = '';

	public onInputClientAddCallModal(params: any) { // CLIENT INPUT
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			if (params.value) {
				console.log(params);
				const productInstance = InstanceService.getInstanceZdSelect('productAdd');
				productInstance.datasource.filter.CDCLIENTE = params.component.value;
				try {
					await productInstance.datasource.get();
					// await productInstance.datasource.setFilter({ CDCLIENTE: params.component.value });
					this.clientNOTSelected = false;
					this.currentCustomer = params.component.value;
					this.currentCustomerCorporateName = params.component.selectedData.NMRAZSOCCLIE;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.typeIsIAdd = false;
					this.typeIsSAdd = false;
					this.clientNOTSelected = true;
					this.productNOTSelected = true;
					this.screenNameNOTSelected = true;
					this.productTypeNOTSelected = true;
					this.versionSNOTSelected = true;
					this.releaseNOTSelected = true;
					this.currentCustomer = '';
					this.currentCustomerCorporateName = '';
					this.currentSgSistema = '';
					this.currentProductTypeName = '';
					this.currentProductType = '';
					this.currentVersionS = '';
				}
			} else {
				this.typeIsIAdd = false;
				this.typeIsSAdd = false;
				this.clientNOTSelected = true;
				this.productNOTSelected = true;
				this.screenNameNOTSelected = true;
				this.productTypeNOTSelected = true;
				this.versionSNOTSelected = true;
				this.releaseNOTSelected = true;
				this.currentCustomer = '';
				this.currentCustomerCorporateName = '';
				this.currentSgSistema = '';
				this.currentProductTypeName = '';
				this.currentProductType = '';
				this.currentVersionS = '';
			}
		}, 350);
	}

	// public clientChangeReset() {
	// 	const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAdd');
	// 	const useLicenseInstance = InstanceService.getInstanceZdSelect('useLicenseAdd');
	// }

	public onInputProductAddCallModal(params: any) { // PRODUCT
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			if (params.value) {
				const categoryInstance = InstanceService.getInstanceZdSelect('categoryAdd');
				console.log(categoryInstance);
				if (params.component.selectValue.PLATAFORMA === 'MOBILE') {
					const screenNameInstance = InstanceService.getInstanceZdSelect('screenNameAdd');
					this.setIValidations();
					this.removeSValidations();
					categoryInstance.datasource.filter.APPLICATION_TYPE = 'I';
					screenNameInstance.datasource.filter.CDCLIENTE = this.currentCustomer;
					screenNameInstance.datasource.filter.PRODUCT_ID = params.component.value;
					try {
						await categoryInstance.datasource.get();
						await screenNameInstance.datasource.get();
						// await categoryInstance.datasource.setFilter({ APPLICATION_TYPE: 'I' });
						// await screenNameInstance.datasource.setFilter({ CDCLIENTE: this.currentCustomer, PRODUCT_ID: params.component.value });
						this.typeIsIAdd = true;
						this.typeIsSAdd = false;
						this.productNOTSelected = false;
					} catch (e) {
						DialogServiceCustom.showErrorBackend(e);
						this.typeIsIAdd = false;
						this.typeIsSAdd = false;
						this.productNOTSelected = true;
						this.screenNameNOTSelected = true;
						this.productTypeNOTSelected = true;
						this.versionSNOTSelected = true;
						this.releaseNOTSelected = true;
						this.currentSgSistema = '';
						this.currentProductTypeName = '';
						this.currentProductType = '';
						this.currentVersionS = '';
						this.removeIValidations();
						this.removeSValidations();
					}
				} else {
					const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAdd');
					const useLicenseInstance = InstanceService.getInstanceZdSelect('useLicenseAdd');
					this.setSValidations();
					this.removeIValidations();
					categoryInstance.datasource.filter.APPLICATION_TYPE = 'S';
					productTypeInstance.datasource.filter.PRODUCT_CODE = params.component.value;
					useLicenseInstance.datasource.filter.CDCLIENTE = this.currentCustomer;
					try {
						await categoryInstance.datasource.setFilter({ APPLICATION_TYPE: 'S' });
						await productTypeInstance.datasource.setFilter({ PRODUCT_CODE: params.component.value });
						await useLicenseInstance.datasource.setFilter({ CDCLIENTE: this.currentCustomer });
						// await categoryInstance.datasource.setFilter({ APPLICATION_TYPE: 'S' });
						// await productTypeInstance.datasource.setFilter({ PRODUCT_CODE: params.component.value });
						// await useLicenseInstance.datasource.setFilter({ CDCLIENTE: this.currentCustomer });
						this.typeIsIAdd = false;
						this.typeIsSAdd = true;
						this.productNOTSelected = false;
						this.currentSgSistema = params.component.selectedData.SGSISTEMA;
					} catch (e) {
						DialogServiceCustom.showErrorBackend(e);
						this.typeIsIAdd = false;
						this.typeIsSAdd = false;
						this.productNOTSelected = true;
						this.screenNameNOTSelected = true;
						this.productTypeNOTSelected = true;
						this.versionSNOTSelected = true;
						this.releaseNOTSelected = true;
						this.currentSgSistema = '';
						this.currentProductTypeName = '';
						this.currentProductType = '';
						this.currentVersionS = '';
						this.removeIValidations();
						this.removeSValidations();
					}
				}
			} else {
				this.typeIsIAdd = false;
				this.typeIsSAdd = false;
				this.productNOTSelected = true;
				this.screenNameNOTSelected = true;
				this.productTypeNOTSelected = true;
				this.versionSNOTSelected = true;
				this.releaseNOTSelected = true;
				this.currentSgSistema = '';
				this.currentProductTypeName = '';
				this.currentProductType = '';
				this.currentVersionS = '';
				this.removeIValidations();
				this.removeSValidations();
			}
		}, 350);
	}

	public setIValidations() {
		const screenNameInstance = InstanceService.getInstanceZdSelect('screenNameAdd');
		const versionIInstance = InstanceService.getInstanceZdSelect('versionIAdd');
		screenNameInstance.addValidation('required');
		versionIInstance.addValidation('required');
	}

	public removeIValidations() {
		const screenNameInstance = InstanceService.getInstanceZdSelect('screenNameAdd');
		const versionIInstance = InstanceService.getInstanceZdSelect('versionIAdd');
		screenNameInstance.removeValidation('required');
		versionIInstance.removeValidation('required');
	}

	public setSValidations() {
		const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAdd');
		const useLicenseInstance = InstanceService.getInstanceZdSelect('useLicenseAdd');
		const versionSInstance = InstanceService.getInstanceZdSelect('versionSAdd');
		const releaseInstance = InstanceService.getInstanceZdSelect('releaseAdd');
		const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
		productTypeInstance.addValidation('required');
		useLicenseInstance.addValidation('required');
		versionSInstance.addValidation('required');
		releaseInstance.addValidation('required');
		patchInstance.addValidation('required');
	}

	public removeSValidations() {
		const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAdd');
		const useLicenseInstance = InstanceService.getInstanceZdSelect('useLicenseAdd');
		const versionSInstance = InstanceService.getInstanceZdSelect('versionSAdd');
		const releaseInstance = InstanceService.getInstanceZdSelect('releaseAdd');
		const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
		productTypeInstance.removeValidation('required');
		useLicenseInstance.removeValidation('required');
		versionSInstance.removeValidation('required');
		releaseInstance.removeValidation('required');
		patchInstance.removeValidation('required');
	}

	public onInputScreenNameAddCallModal(params: any) { // SCREEN NAME
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			if (params.value) {
				console.log(params);
				const versionIInstance = InstanceService.getInstanceZdSelect('versionIAdd');
				versionIInstance.datasource.filter.PRODUCT_ID = params.component.value;
				try {
					await versionIInstance.datasource.get();
					// await versionIInstance.datasource.setFilter({ PRODUCT_ID: params.component.value });
					this.screenNameNOTSelected = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.screenNameNOTSelected = true;
				}
			} else {
				this.screenNameNOTSelected = true;
			}
		}, 350);
	}

	public onInputProductTypeAddCallModal(params: any) { // PRODUCT TYPE
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			const versionSInstance = InstanceService.getInstanceZdSelect('versionSAdd');
			const releaseInstance = InstanceService.getInstanceZdSelect('releaseAdd');
			const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
			if (params.value) {
				console.log(params);
				versionSInstance.datasource.filter.PRODUCT_TYPE = params.component.value;
				versionSInstance.datasource.filter.PRODUCT_CONCAT = `${params.component.selectedData.CDARVPROD}${this.currentSgSistema}`;
				try {
					const version = await versionSInstance.datasource.get();
					// const version = await versionSInstance.datasource.setFilter({ PRODUCT_TYPE: params.component.value,
					// PRODUCT_CONCAT: `${params.component.selectedData.CDARVPROD}${this.currentSgSistema}` });
					if (version.length === 1) {
						this.versionSNOTSelected = false;
						this.currentVersionS = version[0].ID;
						versionSInstance.value = version[0].ID;
						releaseInstance.datasource.filter.PRODUCT_TYPE = params.component.value;
						releaseInstance.datasource.filter.PRODUCT_VERSION = version[0].ID;
						const release = await releaseInstance.datasource.get();
						// const release = await releaseInstance.datasource.setFilter({ PRODUCT_TYPE: params.component.value, PRODUCT_VERSION: version[0].ID });
						if (release.length === 1) {
							this.releaseNOTSelected = false;
							releaseInstance.value = release[0].ID;
							patchInstance.datasource.filter.PRODUCT_TYPE = params.component.value;
							patchInstance.datasource.filter.PRODUCT_VERSION = version[0].ID;
							patchInstance.datasource.filter.PRODUCT_RELEASE = release[0].ID;
							await patchInstance.datasource.get();
							// await patchInstance.datasource.setFilter({ PRODUCT_TYPE: params.component.value, PRODUCT_VERSION: version[0].ID, PRODUCT_RELEASE: release[0].ID });
						}
					}
					this.currentProductTypeName = params.component.value;
					this.currentProductType = params.component.value;
					this.productTypeNOTSelected = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.productTypeNOTSelected = true;
					this.versionSNOTSelected = true;
					this.releaseNOTSelected = true;
					this.currentProductTypeName = '';
					this.currentProductType = '';
					this.currentVersionS = '';
					versionSInstance.value = '';
					releaseInstance.value = '';
					patchInstance.value = '';
				}
			} else {
				this.productTypeNOTSelected = true;
				this.versionSNOTSelected = true;
				this.releaseNOTSelected = true;
				this.currentProductTypeName = '';
				this.currentProductType = '';
				this.currentVersionS = '';
				versionSInstance.value = '';
				releaseInstance.value = '';
				patchInstance.value = '';
			}
		}, 350);
	}

	public onInputVersionSAddCallModal(params: any) { // VERSION S (DELPHI)
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			const releaseInstance = InstanceService.getInstanceZdSelect('releaseAdd');
			const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
			if (params.value) {
				releaseInstance.datasource.filter.PRODUCT_TYPE = this.currentProductType;
				releaseInstance.datasource.filter.PRODUCT_VERSION = params.component.value;
				try {
					const release = await releaseInstance.datasource.get();
					// const release = await releaseInstance.datasource.setFilter({ PRODUCT_TYPE: this.currentProductType, PRODUCT_VERSION: params.component.value });
					if (release.length === 1) {
						releaseInstance.value = release[0].ID;
						this.releaseNOTSelected = false;
						patchInstance.datasource.filter.PRODUCT_TYPE = this.currentProductType;
						patchInstance.datasource.filter.PRODUCT_VERSION = params.component.value;
						patchInstance.datasource.filter.PRODUCT_RELEASE = release[0].ID;
						await patchInstance.datasource.get();
						// await patchInstance.datasource.setFilter({ PRODUCT_TYPE: this.currentProductType, PRODUCT_VERSION: params.component.value, PRODUCT_RELEASE: release[0].ID });
					}
					this.currentVersionS = params.component.value;
					this.versionSNOTSelected = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.versionSNOTSelected = true;
					this.releaseNOTSelected = true;
					this.currentVersionS = '';
					releaseInstance.value = '';
					patchInstance.value = '';
				}
			} else {
				this.versionSNOTSelected = true;
				this.releaseNOTSelected = true;
				this.currentVersionS = '';
				releaseInstance.value = '';
				patchInstance.value = '';
			}
		}, 350);
	}

	public onInputReleaseAddCallModal(params: any) { // RELEASE
		clearTimeout(this.defaultTimeoutTimer);
		this.defaultTimeoutTimer = setTimeout(async () => {
			this.resetValidations();
			const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
			if (params.value) {
				patchInstance.datasource.filter.PRODUCT_TYPE = this.currentProductType;
				patchInstance.datasource.filter.PRODUCT_VERSION = this.currentVersionS;
				patchInstance.datasource.filter.PRODUCT_RELEASE = params.component.value;
				try {
					await patchInstance.datasource.get();
					// await patchInstance.datasource.setFilter({ PRODUCT_TYPE: this.currentProductType, PRODUCT_VERSION: this.currentVersionS, PRODUCT_RELEASE: params.component.value });
					this.releaseNOTSelected = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.releaseNOTSelected = true;
					patchInstance.value = '';
				}
			} else {
				this.releaseNOTSelected = true;
				patchInstance.value = '';
			}
		}, 350);
	}

	// public resetFields() {
	// 	const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAdd');
	// 	const versionSInstance = InstanceService.getInstanceZdSelect('versionSAdd');
	// 	const releaseInstance = InstanceService.getInstanceZdSelect('releaseAdd');
	// 	const patchInstance = InstanceService.getInstanceZdSelect('patchAdd');
	// }

	public saveAddNewCall() {
		const addCallInstance = InstanceService.getInstanceZdForm('formAddCall');
		console.log(addCallInstance);
		const checkValidation = addCallInstance.validate();
		console.log(checkValidation);
		if (this.typeIsIAdd) {
			const sendObject = {
				REFERENCE: addCallInstance.value.referenceAdd,
				REPORTER_ID: '',
				CALL_LABELS: addCallInstance.value.labelsAdd,
				DESCRIPTION: addCallInstance.value.descriptionAdd,
				REPORTED_BY: '',
				CDCLIENTE: this.currentCustomer,
				PLATAFORMA: 'MOBILE',
				PROJECT_ID: '',
				SGSISTEMA: null,
				TYPE: 'I',
				PRODUCT_VERSION: '0',
				PRODUCT_RELEASE: '0',
				MENU_ITEM_ID: addCallInstance.value.screenNameAdd,
				DEVOPS_ID: '',
				MENU_VERSION_ID: addCallInstance.value.versionIAdd,
				CLASSIFICATION: addCallInstance.value.categoryAdd,
				APPOINTMENT_DATE: addCallInstance.value.appointmentDateAdd,
			};
			console.log(sendObject);
		} else {
			const sendObject = {
				REFERENCE: addCallInstance.value.referenceAdd,
				PRODUCT_TYPE_NAME: this.currentProductTypeName,
				MENU_ITEM: '',
				MENU_VERSION: '',
				REPORTER_ID: '',
				NMRAZSOCCLIE: this.currentCustomerCorporateName,
				CALL_LABELS: addCallInstance.value.labelsAdd,
				DESCRIPTION: addCallInstance.value.descriptionAdd,
				REPORTED_BY: '',
				CDCLIENTE: this.currentCustomer,
				PLATAFORMA: 'DELPHI',
				PROJECT_ID: null,
				SGSISTEMA: this.currentSgSistema,
				TYPE: 'S',
				PRODUCT_VERSION: addCallInstance.value.versionSAdd,
				PRODUCT: addCallInstance.value.productAdd,
				PRODUCT_RELEASE: addCallInstance.value.releaseAdd,
				PRODUCT_TYPE: addCallInstance.value.productTypeAdd,
				CDARVPROD: '',
				CLASSIFICATION: addCallInstance.value.categoryAdd,
				PRODUCT_PATCH: addCallInstance.value.patchAdd,
				USE_LICENSE: addCallInstance.value.useLicenseAdd,
				APPOINTMENT_DATE: addCallInstance.value.appointmentDateAdd,
			};
			console.log(sendObject);
		}
		// Http.post('productCallSave');
	}

	public resetValidations() {
		const addCallInstance = InstanceService.getInstanceZdForm('formAddCall');
		addCallInstance.resetValidation();
	}

	public closeAddModalDemandManagementGrid() {
		this.modalAddCall.hide();
		this.typeIsIAdd = false;
		this.typeIsSAdd = false;
		this.clientNOTSelected = true;
		this.productNOTSelected = true;
		this.screenNameNOTSelected = true;
		this.productTypeNOTSelected = true;
		this.versionSNOTSelected = true;
		this.releaseNOTSelected = true;
		this.currentCustomer = '';
		this.currentCustomerCorporateName = '';
		this.currentSgSistema = '';
		this.currentProductType = '';
		this.currentVersionS = '';
	}
	// END MODAL ADD CALL ----

	// START MODAL FORWARD CALL ---
	public forwardCallType = '';

	public forwardCallRelationship = '';

	public async clickOpenForwardCall(params) {
		console.log(params);
		try {
			this.forwardCallType = params.row.TYPE;
			this.forwardCallRelationship = params.row.CALL_RELATIONSHIP;
			const sendObject = { params: {
					CALL_TYPE: this.forwardCallType,
					CALL_RELATIONSHIP: this.forwardCallRelationship,
					LANG: 'pt',
				},
			};
			await Http.get('/questionForSendCall', sendObject);
			this.modalForwardCall.show();
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
	}

	public closeModalForwardCall() {
		this.modalForwardCall.hide();
		this.forwardCallRelationship = '';
		this.forwardCallType = '';
	}
	// END MODAL FORWARD CALL ---

	// START CALL TAB ----
	public editCallButton() {
		console.log('alo');
	}

	public clickBackCardFormDemandManagement() {
		const tabsInstance = Metadata.getInstance<ITabsBeforeChangeEventParam>('tabMainFormDemandManagement');
		tabsInstance.activeTab = 0;
		this.showDemandManagementForm = false;
	}

	public clickProductOnForm() {
		console.log('click product');
		// Da um get em findProductCallProducts
	}

	public changeProductOnForm(params: any) {
		if (params.value) {
			// Da um get em findMenuItems
			// Da um get em findProductVersion
			console.log('change product');
			console.log(params);
		}
	}

	public changeScreenNameOnForm(params: any) {
		if (params.value) {
			// Da um get em findProductVersion
			console.log('change screenName');
			console.log(params);
		}
	}
	// END CALL TAB ------

	// START COMMENTS TAB --
	public onCreatedIterableComments(params: any) {
		if (params.component.activeTab === 1) {
			setTimeout(async () => {
				await this.updateIterableComments();
			}, 1);
		}
		// DOCUMENTS TAB
		if (params.component.activeTab === 2) {
			setTimeout(async () => {
				const gridAttachments = Metadata.getInstance<any>('gridAttachments');
				console.log(gridAttachments);
				gridAttachments.datasource.filter.CALL_TYPE = this.callType;
				gridAttachments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
				try {
					await gridAttachments.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			}, 1);
		}
	}

	public async onMountedButtonAddComments() {
		this.modalAddComments = await ModalService.createFromJson('demandManagement/modal/addCommentsDemandManagementModal', true);
	}

	public onDestroyButtonAddComments() {
		this.modalAddComments?.destroy();
	}

	public clickIterableComments(params: any) {
		console.log(params);
	}

	public onMountedCollapseCardComments(params: any) {
		params.component.readonly = params.component.readonly === 'true';
		params.component.hideAction = params.component.hideAction === 'true';
	}

	public onMountedBuildFileIterableData(params: any) {
		const id = params.component.name.split('-')[1];
		// const collapseCardInstance = Metadata.getInstance<CollapseCard>(`collapseCard-${id}`);
		const iterableCommentsInstance = Metadata.getInstance<IterableComponentRender>('iterableComments');
		const rowData = iterableCommentsInstance.datasource.data.find((row) => row.ID === id);
		if (rowData) {
			if (rowData.ATTACHMENT.length > 0) {
				params.component.datasource.data = rowData.ATTACHMENT;
			}
		}
	}

	public downloadFileComment(params: any) {
		const fileId = params.element.name.split('-')[1];
		const commentId = params.element.name.split('-')[2];
		const fileInstance = Metadata.getInstance<IterableComponentRender>(`iterableFiles-${commentId}`);
		const fileSelected = fileInstance.datasource.data.find((file) => file.ID === fileId);
		if (fileSelected) {
			if (this.callType === 'I') {
				const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${fileSelected.ID}`;
				window.open(downloadUri);
			} else {
				const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${fileSelected.FILE_NAME}`;
				window.open(downloadUri);
			}
		}
	}

	public async updateIterableComments() {
		const iterableComments = Metadata.getInstance<IterableComponentRender>('iterableComments');
		iterableComments.datasource.filter.CALL_TYPE = this.callType;
		iterableComments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
		try {
			await iterableComments.datasource.get();
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
	}
	// END COMMENTS TAB ----

	// START COMMENTS MODAL ----
	public defaultPublicCommentValue = 'N';

	public addCommentButton() {
		this.modalAddComments.show();
		if (this.publicComment) {
			this.defaultPublicCommentValue = 'Y';
		}
	}

	public closeAddCommentsModal() {
		this.modalAddComments.hide();
		this.defaultPublicCommentValue = 'N';
	}

	public get switchButtonDisabledAddCommentsModal() {
		if (this.publicComment) {
			return true;
		}
		return this.isLoadingDefault;
	}

	public async saveAddComment() {
		const addCommentInstance = InstanceService.getInstanceZdForm('formAddCommentsModal');
		const commentValidation = addCommentInstance.validate();
		console.log(addCommentInstance);
        if (commentValidation) {
			this.isLoadingDefault = true;
			const fileInput: any = Metadata.getInstance('fileInputAddCommentsModal');
			if (fileInput.value && fileInput.value.length > 0) {
				let mimeCheck = true;
				const checkFile = fileInput.value.map((file: any) => {
					if ((file.type === 'application/msword'
					|| file.type === 'image/jpeg'
					|| file.type === 'image/png'
					|| file.type === 'application/pdf'
					|| file.type === 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'
					|| file.type === 'application/vnd.ms-excel.sheet.macroenabled.12'
					|| file.type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
					|| file.type === 'application/vnd.ms-excel'
					|| file.type === 'text/plain'
					|| file.type === 'application/zip')
					&& file.size < 50000000) {
						return FileUpload.buildFileSendObject(file);
					}
					mimeCheck = false;
					return false;
				});
				if (mimeCheck) {
					Promise.all(checkFile).then(async (fileArray) => {
						try {
							await Http.post('/callAttachmentSave', {
								CALL_RELATIONSHIP: this.callRelationship,
								CALL_TYPE: this.callType,
								DESCRIPTION: addCommentInstance.value.commentTextAreaAddCommentsModal,
								PUBLIC: addCommentInstance.value.switchButtonAddCommentsModal,
								DOCUMENT: fileArray,
								requestType: 'DataSet',
							});
							this.updateIterableComments();
							this.closeAddCommentsModal();
							AlertServiceCustom.defaultSaveSuccessAlert();
							this.isLoadingDefault = false;
						} catch (e) {
							DialogServiceCustom.showErrorBackend(e);
							this.isLoadingDefault = false;
						}
					});
				} else {
					AlertServiceCustom.customErrorAlert(Messages.ERROR_FILE_TYPE);
					this.isLoadingDefault = false;
				}
			} else {
				try {
					await Http.post('/callAttachmentSave', {
						CALL_RELATIONSHIP: this.callRelationship,
						CALL_TYPE: this.callType,
						DESCRIPTION: addCommentInstance.value.commentTextAreaAddCommentsModal,
						PUBLIC: addCommentInstance.value.switchButtonAddCommentsModal,
						DOCUMENT: [],
						requestType: 'DataSet',
					});
					this.updateIterableComments();
					this.closeAddCommentsModal();
					AlertServiceCustom.defaultSaveSuccessAlert();
					this.isLoadingDefault = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
					this.isLoadingDefault = false;
				}
			}
        }
	}
	// END COMMENTS MODAL ----

	// START DOCUMENTS TAB ---
	public async onMountedGridAttachments() {
		this.modalUploadFile = await ModalService.createFromJson('demandManagement/modal/uploadFileDemandManagementModal', true);
	}

	public onDestroyGridAttachments() {
		this.modalUploadFile.destroy();
	}

	public addClickGridAttachments() {
		this.modalUploadFile.show();
		// const grid = Metadata.getInstance<TekGrid>('gridAttachments');
		// console.log(grid);
	}

	public downloadFileGrid(params: any) {
		if (this.callType === 'I') {
			const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${params.row.ID}`;
			window.open(downloadUri);
		} else {
			const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${params.row.FILE_NAME}`;
			window.open(downloadUri);
		}
	}

	public async deleteAttachmentsGrid(params: any) {
		params.event.preventDefault();
		LoadingService.show('Carregando');
		try {
			await Http.post('deleteProductCallAttachments', params.component.selectedRows);
			params.component.selectedRows = [];
			this.updateFileGrid();
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
		LoadingService.hide();
	}

	public async updateFileGrid() {
		const gridAttachments = Metadata.getInstance<any>('gridAttachments');
		try {
			await gridAttachments.datasource.get();
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
	}
	// END DOCUMENTS TAB -----

	// START DOCUMENTS MODAL ---
	public async saveUploadFileModal() {
		this.isLoadingDefault = true;
		let mimeCheck = true;
        const fileInput: any = Metadata.getInstance('fileInputUploadFileDemandManagementModal');
        if (fileInput.value && fileInput.value.length > 0) {
			const checkFile = fileInput.value.map((file: any) => {
				if ((file.type === 'application/msword'
				|| file.type === 'image/jpeg'
				|| file.type === 'image/png'
				|| file.type === 'application/pdf'
				|| file.type === 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'
				|| file.type === 'application/vnd.ms-excel.sheet.macroenabled.12'
				|| file.type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
				|| file.type === 'application/vnd.ms-excel'
				|| file.type === 'text/plain'
				|| file.type === 'application/zip')
				&& file.size < 50000000) {
					return FileUpload.buildFileSendObject(file);
				}
				mimeCheck = false;
				return false;
			});
			if (mimeCheck) {
				Promise.all(checkFile).then(async (fileArray) => {
					try {
						await Http.post('/callAttachmentSave', {
							CALL_RELATIONSHIP: this.callRelationship,
							CALL_TYPE: this.callType,
							DOCUMENT: fileArray,
							requestType: 'DataSet',
						});
						this.updateFileGrid();
						this.modalUploadFile.hide();
						AlertServiceCustom.defaultSaveSuccessAlert();
						this.isLoadingDefault = false;
					} catch (e) {
						DialogServiceCustom.showErrorBackend(e);
						this.isLoadingDefault = false;
					}
				});
			} else {
				AlertServiceCustom.customErrorAlert(Messages.ERROR_FILE_TYPE);
				this.isLoadingDefault = false;
			}
        } else {
			AlertServiceCustom.customErrorAlert(Messages.ERROR_FILE_EXPECTED);
			this.isLoadingDefault = false;
        }
	}

	public closeUploadFileModal() {
		this.modalUploadFile.hide();
	}
	// END DOCUMENTS MODAL -----
}
